Revert "test-lib: support running tests under valgrind in parallel"
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
2d14e13c
JK
57 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
58 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
8bade1e1 95unset GITPERLLIB
29e55cd5
JH
96GIT_AUTHOR_EMAIL=author@example.com
97GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
98GIT_COMMITTER_EMAIL=committer@example.com
99GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 100GIT_MERGE_VERBOSITY=5
f8246281
JH
101GIT_MERGE_AUTOEDIT=no
102export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
103export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 105export EDITOR
e1970ce4 106
a731fa91
EP
107# Add libc MALLOC and MALLOC_PERTURB test
108# only if we are not executing the test with valgrind
1b3185fc 109if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 110 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
111then
112 setup_malloc_check () {
113 : nothing
114 }
115 teardown_malloc_check () {
116 : nothing
117 }
118else
119 setup_malloc_check () {
120 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
121 export MALLOC_CHECK_ MALLOC_PERTURB_
122 }
123 teardown_malloc_check () {
124 unset MALLOC_CHECK_ MALLOC_PERTURB_
125 }
126fi
a731fa91 127
886a3907
JH
128# Protect ourselves from common misconfiguration to export
129# CDPATH into the environment
130unset CDPATH
131
5565f47c 132unset GREP_OPTIONS
ac001282 133unset UNZIP
5565f47c 134
3d5c0cc9 135case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1361|2|true)
137 echo "* warning: Some tests will not work if GIT_TRACE" \
138 "is set as to trace on STDERR ! *"
139 echo "* warning: Please set GIT_TRACE to something" \
140 "other than 1, 2 or true ! *"
141 ;;
6ce4e61f
CC
142esac
143
cd3c095c
JH
144# Convenience
145#
146# A regexp to match 5 and 40 hexdigits
147_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
149
3749fde5
JH
150# Zero SHA-1
151_z40=0000000000000000000000000000000000000000
152
3f4ab627
JH
153# Line feed
154LF='
155'
156
342e9ef2
TR
157export _x05 _x40 _z40 LF
158
e1970ce4
JH
159# Each test should start with something like this, after copyright notices:
160#
161# test_description='Description of this test...
162# This test checks if command xyzzy does the right thing...
163# '
164# . ./test-lib.sh
c2116a17
JH
165[ "x$ORIGINAL_TERM" != "xdumb" ] && (
166 TERM=$ORIGINAL_TERM &&
167 export TERM &&
168 [ -t 1 ] &&
169 tput bold >/dev/null 2>&1 &&
170 tput setaf 1 >/dev/null 2>&1 &&
171 tput sgr0 >/dev/null 2>&1
172 ) &&
55db1df0 173 color=t
e1970ce4 174
e1970ce4
JH
175while test "$#" -ne 0
176do
177 case "$1" in
178 -d|--d|--de|--deb|--debu|--debug)
179 debug=t; shift ;;
886856ab
JH
180 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
181 immediate=t; shift ;;
5e2c08c6 182 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 183 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 184 -h|--h|--he|--hel|--help)
570f3226 185 help=t; shift ;;
e1970ce4
JH
186 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
187 verbose=t; shift ;;
ff09af3f
TR
188 --verbose-only=*)
189 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
190 shift ;;
1ece1274 191 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
192 # Ignore --quiet under a TAP::Harness. Saying how many tests
193 # passed without the ok/not ok details is always an error.
194 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
195 --with-dashes)
196 with_dashes=t; shift ;;
55db1df0 197 --no-color)
faa4bc35 198 color=; shift ;;
4e1be63c 199 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
200 valgrind=memcheck
201 shift ;;
202 --valgrind=*)
203 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
204 shift ;;
5dfc368f
TR
205 --valgrind-only=*)
206 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
207 shift ;;
44138559
JS
208 --tee)
209 shift ;; # was handled already
f423ef5f
JK
210 --root=*)
211 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
e939e15d
TR
213 --statusprefix=*)
214 statusprefix=$(expr "z$1" : 'z[^=]*=\(.*\)')
215 shift ;;
e1970ce4 216 *)
1f729dca 217 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
218 esac
219done
220
26a07309 221if test -n "$valgrind_only"
5dfc368f
TR
222then
223 test -z "$valgrind" && valgrind=memcheck
224 test -z "$verbose" && verbose_only="$valgrind_only"
225elif test -n "$valgrind"
226then
227 verbose=t
228fi
952af351 229
1c0cc756
RJ
230if test -n "$color"
231then
55db1df0 232 say_color () {
c2116a17
JH
233 (
234 TERM=$ORIGINAL_TERM
235 export TERM
55db1df0 236 case "$1" in
1c0cc756
RJ
237 error)
238 tput bold; tput setaf 1;; # bold red
239 skip)
b8fc855a 240 tput setaf 4;; # blue
e8e51955
AS
241 warn)
242 tput setaf 3;; # brown/yellow
1c0cc756 243 pass)
0a6d4751 244 tput setaf 2;; # green
1c0cc756 245 info)
0a6d4751 246 tput setaf 6;; # cyan
1c0cc756
RJ
247 *)
248 test -n "$quiet" && return;;
55db1df0
PH
249 esac
250 shift
5099b99d 251 printf "%s" "$*"
55db1df0 252 tput sgr0
b8eecafd 253 echo
c2116a17 254 )
55db1df0
PH
255 }
256else
257 say_color() {
1ece1274 258 test -z "$1" && test -n "$quiet" && return
55db1df0 259 shift
7bc0911d 260 printf "%s\n" "$*"
55db1df0
PH
261 }
262fi
263
264error () {
265 say_color error "error: $*"
6e7b5aaf 266 GIT_EXIT_OK=t
55db1df0
PH
267 exit 1
268}
269
270say () {
271 say_color info "$*"
272}
273
570f3226
MB
274test "${test_description}" != "" ||
275error "Test script did not set test_description."
276
277if test "$help" = "t"
278then
279 echo "$test_description"
280 exit 0
281fi
282
4d9d62fa 283exec 5>&1
781f76b1 284exec 6<&0
e1970ce4
JH
285if test "$verbose" = "t"
286then
287 exec 4>&2 3>&1
288else
289 exec 4>/dev/null 3>/dev/null
290fi
291
292test_failure=0
293test_count=0
41ac414e
JH
294test_fixed=0
295test_broken=0
2d84e9fb 296test_success=0
e1970ce4 297
d998bd4a
ÆAB
298test_external_has_tap=0
299
faa4bc35 300die () {
6e7b5aaf
CB
301 code=$?
302 if test -n "$GIT_EXIT_OK"
303 then
304 exit $code
305 else
306 echo >&5 "FATAL: Unexpected exit with code $code"
307 exit 1
308 fi
faa4bc35
CB
309}
310
6e7b5aaf 311GIT_EXIT_OK=
35641310 312trap 'die' EXIT
41184273 313
12a29b1a
TR
314# The user-facing functions are loaded from a separate file so that
315# test_perf subshells can have them too
3c8f12c9 316. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 317
886856ab
JH
318# You are not expected to call test_ok_ and test_failure_ directly, use
319# the text_expect_* functions instead.
320
321test_ok_ () {
d5d9de1b 322 test_success=$(($test_success + 1))
e939e15d 323 say_color "" "${statusprefix}ok $test_count - $@"
e1970ce4
JH
324}
325
886856ab 326test_failure_ () {
d5d9de1b 327 test_failure=$(($test_failure + 1))
e939e15d 328 say_color error "${statusprefix}not ok $test_count - $1"
bf0dd8a8 329 shift
5099b99d 330 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 331 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
332}
333
41ac414e 334test_known_broken_ok_ () {
41ac414e 335 test_fixed=$(($test_fixed+1))
e939e15d 336 say_color error "${statusprefix}ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
337}
338
339test_known_broken_failure_ () {
41ac414e 340 test_broken=$(($test_broken+1))
e939e15d 341 say_color warn "${statusprefix}not ok $test_count - $@ # TODO known breakage"
41ac414e 342}
886856ab
JH
343
344test_debug () {
8e832ebc 345 test "$debug" = "" || eval "$1"
e1970ce4
JH
346}
347
e6a6ddc9
TR
348match_pattern_list () {
349 arg="$1"
350 shift
351 test -z "$*" && return 1
352 for pattern_
353 do
354 case "$arg" in
355 $pattern_)
356 return 0
357 esac
358 done
359 return 1
360}
361
ff09af3f
TR
362maybe_teardown_verbose () {
363 test -z "$verbose_only" && return
364 exec 4>/dev/null 3>/dev/null
365 verbose=
366}
367
368last_verbose=t
369maybe_setup_verbose () {
370 test -z "$verbose_only" && return
26a07309 371 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
372 then
373 exec 4>&2 3>&1
374 # Emit a delimiting blank line when going from
375 # non-verbose to verbose. Within verbose mode the
376 # delimiter is printed by test_expect_*. The choice
377 # of the initial $last_verbose is such that before
378 # test 1, we do not print it.
379 test -z "$last_verbose" && echo >&3 ""
380 verbose=t
381 else
382 exec 4>/dev/null 3>/dev/null
383 verbose=
384 fi
385 last_verbose=$verbose
386}
387
5dfc368f
TR
388maybe_teardown_valgrind () {
389 test -z "$GIT_VALGRIND" && return
390 GIT_VALGRIND_ENABLED=
391}
392
393maybe_setup_valgrind () {
394 test -z "$GIT_VALGRIND" && return
26a07309 395 if test -z "$valgrind_only"
5dfc368f
TR
396 then
397 GIT_VALGRIND_ENABLED=t
398 return
399 fi
400 GIT_VALGRIND_ENABLED=
401 if match_pattern_list $test_count $valgrind_only
402 then
403 GIT_VALGRIND_ENABLED=t
404 fi
405}
406
a7c58f28
JN
407test_eval_ () {
408 # This is a separate function because some tests use
409 # "return" to end a test_expect_success block early.
781f76b1 410 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
411}
412
4d9d62fa 413test_run_ () {
b6b0afdc 414 test_cleanup=:
b586744a 415 expecting_failure=$2
a57397b0 416 setup_malloc_check
a7c58f28 417 test_eval_ "$1"
b6b0afdc 418 eval_ret=$?
a57397b0 419 teardown_malloc_check
b586744a
JH
420
421 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
422 then
1b3185fc 423 setup_malloc_check
a7c58f28 424 test_eval_ "$test_cleanup"
1b3185fc 425 teardown_malloc_check
b586744a 426 fi
1c0cc756
RJ
427 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
428 then
57e1538a
ÆAB
429 echo ""
430 fi
aa0bcf96 431 return "$eval_ret"
4d9d62fa
PR
432}
433
ae75342c 434test_start_ () {
8586f98b 435 test_count=$(($test_count+1))
ff09af3f 436 maybe_setup_verbose
5dfc368f 437 maybe_setup_valgrind
ae75342c
TR
438}
439
440test_finish_ () {
441 echo >&3 ""
5dfc368f 442 maybe_teardown_valgrind
ff09af3f 443 maybe_teardown_verbose
ae75342c
TR
444}
445
446test_skip () {
04ece593 447 to_skip=
e6a6ddc9
TR
448 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
449 then
450 to_skip=t
451 fi
05236a5e
JN
452 if test -z "$to_skip" && test -n "$test_prereq" &&
453 ! test_have_prereq "$test_prereq"
a7bb3940
JS
454 then
455 to_skip=t
456 fi
04ece593
JH
457 case "$to_skip" in
458 t)
07431fc8 459 of_prereq=
05236a5e 460 if test "$missing_prereq" != "$test_prereq"
07431fc8 461 then
05236a5e 462 of_prereq=" of $test_prereq"
07431fc8
JN
463 fi
464
e939e15d
TR
465 say_color skip >&3 "${statusprefix}skipping test: $@"
466 say_color skip "${statusprefix}ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
467 : true
468 ;;
469 *)
470 false
471 ;;
472 esac
473}
474
342e9ef2
TR
475# stub; perf-lib overrides it
476test_at_end_hook_ () {
477 :
478}
479
e1970ce4 480test_done () {
6e7b5aaf 481 GIT_EXIT_OK=t
2d84e9fb 482
517cd55f
TR
483 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
484 # output file
1c0cc756
RJ
485 if test -z "$HARNESS_ACTIVE"
486 then
342e9ef2 487 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 488 mkdir -p "$test_results_dir"
dd78478f
FC
489 base=${0##*/}
490 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 491
c54e6be7
ML
492 cat >>"$test_results_path" <<-EOF
493 total $test_count
494 success $test_success
495 fixed $test_fixed
496 broken $test_broken
497 failed $test_failure
498
499 EOF
8ef1abe5 500 fi
41ac414e
JH
501
502 if test "$test_fixed" != 0
503 then
e939e15d 504 say_color error "${statusprefix}# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
505 fi
506 if test "$test_broken" != 0
507 then
e939e15d 508 say_color warn "${statusprefix}# still have $test_broken known breakage(s)"
b73d9a23
AS
509 fi
510 if test "$test_broken" != 0 || test "$test_fixed" != 0
511 then
512 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
513 msg="remaining $test_remaining test(s)"
11d54b8b 514 else
b73d9a23 515 test_remaining=$test_count
11d54b8b 516 msg="$test_count test(s)"
41ac414e 517 fi
e1970ce4 518 case "$test_failure" in
10b94e28 519 0)
5099b99d 520 # Maybe print SKIP message
bf4b7219
RJ
521 if test -n "$skip_all" && test $test_count -gt 0
522 then
523 error "Can't use skip_all after running some tests"
524 fi
5099b99d
ÆAB
525 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
526
1c0cc756
RJ
527 if test $test_external_has_tap -eq 0
528 then
b73d9a23 529 if test $test_remaining -gt 0
d87bd7c1 530 then
e939e15d 531 say_color pass "${statusprefix}# passed all $msg"
d87bd7c1 532 fi
e939e15d 533 say "${statusprefix}1..$test_count$skip_all"
d998bd4a 534 fi
abc5d372
JS
535
536 test -d "$remove_trash" &&
537 cd "$(dirname "$remove_trash")" &&
538 rm -rf "$(basename "$remove_trash")"
539
342e9ef2
TR
540 test_at_end_hook_
541
e1970ce4
JH
542 exit 0 ;;
543
544 *)
1c0cc756
RJ
545 if test $test_external_has_tap -eq 0
546 then
e939e15d
TR
547 say_color error "${statusprefix}# failed $test_failure among $msg"
548 say "${statusprefix}1..$test_count"
d998bd4a 549 fi
5099b99d 550
e1970ce4
JH
551 exit 1 ;;
552
553 esac
554}
555
e4597aae 556if test -n "$valgrind"
4e1be63c 557then
4e1be63c
JS
558 make_symlink () {
559 test -h "$2" &&
560 test "$1" = "$(readlink "$2")" || {
561 # be super paranoid
562 if mkdir "$2".lock
563 then
564 rm -f "$2" &&
565 ln -s "$1" "$2" &&
566 rm -r "$2".lock
567 else
568 while test -d "$2".lock
569 do
570 say "Waiting for lock on $2."
571 sleep 1
572 done
573 fi
574 }
575 }
576
577 make_valgrind_symlink () {
36bfb0e5
JK
578 # handle only executables, unless they are shell libraries that
579 # need to be in the exec-path. We will just use "#!" as a
580 # guess for a shell-script, since we have no idea what the user
581 # may have configured as the shell path.
582 test -x "$1" ||
583 test "#!" = "$(head -c 2 <"$1")" ||
584 return;
4e1be63c
JS
585
586 base=$(basename "$1")
6cec5c68 587 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
588 # do not override scripts
589 if test -x "$symlink_target" &&
590 test ! -d "$symlink_target" &&
591 test "#!" != "$(head -c 2 < "$symlink_target")"
592 then
593 symlink_target=../valgrind.sh
594 fi
efd92ffd
JS
595 case "$base" in
596 *.sh|*.perl)
597 symlink_target=../unprocessed-script
598 esac
4e1be63c
JS
599 # create the link, or replace it if it is out of date
600 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
601 }
602
26a07309
TR
603 # override all git executables in TEST_DIRECTORY/..
604 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
605 mkdir -p "$GIT_VALGRIND"/bin
606 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
607 do
608 make_valgrind_symlink $file
609 done
610 # special-case the mergetools loadables
611 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
612 OLDIFS=$IFS
613 IFS=:
614 for path in $PATH
615 do
616 ls "$path"/git-* 2> /dev/null |
617 while read file
ad0e6233 618 do
26a07309 619 make_valgrind_symlink "$file"
ad0e6233 620 done
26a07309
TR
621 done
622 IFS=$OLDIFS
4e1be63c
JS
623 PATH=$GIT_VALGRIND/bin:$PATH
624 GIT_EXEC_PATH=$GIT_VALGRIND/bin
625 export GIT_VALGRIND
952af351
TR
626 GIT_VALGRIND_MODE="$valgrind"
627 export GIT_VALGRIND_MODE
5dfc368f 628 GIT_VALGRIND_ENABLED=t
26a07309 629 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 630 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
631elif test -n "$GIT_TEST_INSTALLED"
632then
e4597aae
MO
633 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
634 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 635 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
636 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
637else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 638 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
639 if ! test -x "$git_bin_dir/git"
640 then
641 if test -z "$with_dashes"
642 then
e4597aae
MO
643 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
644 fi
645 with_dashes=t
646 fi
647 PATH="$git_bin_dir:$PATH"
6cec5c68 648 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
649 if test -n "$with_dashes"
650 then
6cec5c68 651 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 652 fi
4e1be63c 653fi
6cec5c68 654GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 655unset GIT_CONFIG
8bfa6bd6 656GIT_CONFIG_NOSYSTEM=1
3c995beb 657GIT_ATTR_NOSYSTEM=1
8f323c00 658export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 659
5e87eae9
JH
660if test -z "$GIT_TEST_CMP"
661then
662 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
663 then
664 GIT_TEST_CMP="$DIFF -c"
665 else
666 GIT_TEST_CMP="$DIFF -u"
667 fi
668fi
669
6cec5c68 670GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 671export GITPERLLIB
6cec5c68 672test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
673 error "You haven't built things yet, have you?"
674}
e1970ce4 675
ac10a857 676if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 677then
6cec5c68 678 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 679 export GITPYTHONLIB
6cec5c68 680 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
681 error "You haven't built git_remote_helpers yet, have you?"
682 }
683fi
684
1c0cc756
RJ
685if ! test -x "$GIT_BUILD_DIR"/test-chmtime
686then
56cf9806
EW
687 echo >&2 'You need to build test-chmtime:'
688 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
689 exit 1
690fi
691
e1970ce4 692# Test repository
002d4ce8
JK
693TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
694test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
695case "$TRASH_DIRECTORY" in
696/*) ;; # absolute path is good
697 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 698esac
91c8b825 699test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 700rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 701 GIT_EXIT_OK=t
8d14ac94
JH
702 echo >&5 "FATAL: Cannot prepare test area"
703 exit 1
704}
705
90cff968
AR
706HOME="$TRASH_DIRECTORY"
707export HOME
708
1c0cc756
RJ
709if test -z "$TEST_NO_CREATE_REPO"
710then
38b074de 711 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 712else
38b074de 713 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 714fi
1bd9c648
LW
715# Use -P to resolve symlinks in our working directory so that the cwd
716# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 717cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 718
d5d9de1b
JS
719this_test=${0##*/}
720this_test=${this_test%%-*}
e6a6ddc9
TR
721if match_pattern_list "$this_test" $GIT_SKIP_TESTS
722then
723 say_color info >&3 "skipping test $this_test altogether"
724 skip_all="skip all tests in $this_test"
725 test_done
726fi
f17e9fbb 727
8648732e
BC
728# Provide an implementation of the 'yes' utility
729yes () {
730 if test $# = 0
731 then
732 y=y
733 else
734 y="$*"
735 fi
736
737 while echo "$y"
738 do
739 :
740 done
741}
742
f17e9fbb
JS
743# Fix some commands on Windows
744case $(uname -s) in
745*MINGW*)
746 # Windows has its own (incompatible) sort and find
747 sort () {
748 /usr/bin/sort "$@"
749 }
750 find () {
751 /usr/bin/find "$@"
752 }
5397ea31
JS
753 sum () {
754 md5sum "$@"
755 }
4114156a
JS
756 # git sees Windows-style pwd
757 pwd () {
758 builtin pwd -W
759 }
ee9fb68c 760 # no POSIX permissions
6fd1106a 761 # backslashes in pathspec are converted to '/'
fb9a2bea 762 # exec does not inherit the PID
a94114ad 763 test_set_prereq MINGW
cfa96496 764 test_set_prereq NOT_CYGWIN
a31d0665 765 test_set_prereq SED_STRIPS_CR
97669eed 766 test_set_prereq GREP_STRIPS_CR
a31d0665
RJ
767 ;;
768*CYGWIN*)
769 test_set_prereq POSIXPERM
a31d0665
RJ
770 test_set_prereq EXECKEEPSPID
771 test_set_prereq NOT_MINGW
cfa96496 772 test_set_prereq CYGWIN
a31d0665 773 test_set_prereq SED_STRIPS_CR
97669eed 774 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
775 ;;
776*)
777 test_set_prereq POSIXPERM
6fd1106a 778 test_set_prereq BSLASHPSPEC
fb9a2bea 779 test_set_prereq EXECKEEPSPID
3ba9ba8f 780 test_set_prereq NOT_MINGW
cfa96496 781 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
782 ;;
783esac
704a3143 784
b082687c 785( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 786test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 787test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 788test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 789test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 790
bb946bba 791# Can we rely on git's output in the C locale?
30955229
JN
792if test -n "$GETTEXT_POISON"
793then
794 GIT_GETTEXT_POISON=YesPlease
795 export GIT_GETTEXT_POISON
5e9637c6 796 test_set_prereq GETTEXT_POISON
30955229
JN
797else
798 test_set_prereq C_LOCALE_OUTPUT
799fi
bb946bba 800
cabdee2c
JH
801# Use this instead of test_cmp to compare files that contain expected and
802# actual output from git commands that can be translated. When running
803# under GETTEXT_POISON this pretends that the command produced expected
804# results.
805test_i18ncmp () {
806 test -n "$GETTEXT_POISON" || test_cmp "$@"
807}
808
127df8c6
JH
809# Use this instead of "grep expected-string actual" to see if the
810# output from a git command that can be translated either contains an
811# expected string, or does not contain an unwanted one. When running
812# under GETTEXT_POISON this pretends that the command produced expected
813# results.
814test_i18ngrep () {
815 if test -n "$GETTEXT_POISON"
816 then
817 : # pretend success
818 elif test "x!" = "x$1"
819 then
820 shift
821 ! grep "$@"
822 else
823 grep "$@"
824 fi
825}
826
20073274
AS
827test_lazy_prereq PIPE '
828 # test whether the filesystem supports FIFOs
9443605b
ML
829 case $(uname -s) in
830 CYGWIN*)
831 false
832 ;;
833 *)
834 rm -f testfifo && mkfifo testfifo
835 ;;
836 esac
20073274
AS
837'
838
04083f27
JH
839test_lazy_prereq SYMLINKS '
840 # test whether the filesystem supports symbolic links
841 ln -s x y && test -h y
842'
c91cfd19 843
ac39aa61
MG
844test_lazy_prereq CASE_INSENSITIVE_FS '
845 echo good >CamelCase &&
846 echo bad >camelcase &&
847 test "$(cat CamelCase)" != good
848'
849
5b0b5dd4
MG
850test_lazy_prereq UTF8_NFD_TO_NFC '
851 # check whether FS converts nfd unicode to nfc
852 auml=$(printf "\303\244")
853 aumlcdiar=$(printf "\141\314\210")
854 >"$auml" &&
855 case "$(echo *)" in
856 "$aumlcdiar")
857 true ;;
858 *)
859 false ;;
860 esac
861'
862
09feffb6
JK
863test_lazy_prereq AUTOIDENT '
864 sane_unset GIT_AUTHOR_NAME &&
865 sane_unset GIT_AUTHOR_EMAIL &&
866 git var GIT_AUTHOR_IDENT
867'
868
c91cfd19
ÆAB
869# When the tests are run as root, permission tests will report that
870# things are writable when they shouldn't be.
871test -w / || test_set_prereq SANITY
f838ce58
JK
872
873GIT_UNZIP=${GIT_UNZIP:-unzip}
874test_lazy_prereq UNZIP '
875 "$GIT_UNZIP" -v
876 test $? -ne 127
877'